diff --git a/tests/emscripten_log/emscripten_log.cpp b/tests/emscripten_log/emscripten_log.cpp
index 854743050bb..0c41fb8383b 100644
--- a/tests/emscripten_log/emscripten_log.cpp
+++ b/tests/emscripten_log/emscripten_log.cpp
@@ -82,7 +82,12 @@ void __attribute__((noinline)) bar(int = 0, char * = 0, double = 0) // Arbitrary
 
 	if ((flags & EM_LOG_C_STACK) != 0)
 	{
-		MYASSERT(!!strstr(callstack, ".cpp:"), "Callstack was %s!", callstack);
+		// TODO(https://github.com/emscripten-core/emscripten/issues/13089):
+		// Source map parsing appears to be broken curently.   Ideally we would
+		// check here that the to inndermost/lowest stack froms are shown to be
+		// coming from `emscripten_log.cpp`.
+		//MYASSERT(!!strstr(callstack, ".cpp:"), "Callstack was %s!", callstack);
+		MYASSERT(!!strstr(callstack, ".c:"), "Callstack was %s!", callstack);
 	}
 	else
 	{
diff --git a/tests/test_core.py b/tests/test_core.py
index ece09250aaa..0f19b42f8c2 100644
--- a/tests/test_core.py
+++ b/tests/test_core.py
@@ -6948,7 +6948,7 @@ def encode_utf8(data):
       # the file attribute is optional, but if it is present it needs to refer
       # the output file.
       self.assertPathsIdentical(map_referent, data['file'])
-    assert len(data['sources']) == 1, data['sources']
+    self.assertGreater(len(data['sources']), 1)
     self.assertPathsIdentical('src.cpp', data['sources'][0])
     if hasattr(data, 'sourcesContent'):
       # the sourcesContent attribute is optional, but if it is present it
@@ -6962,14 +6962,14 @@ def encode_utf8(data):
       mappings = encode_utf8(mappings)
     seen_lines = set()
     for m in mappings:
-      self.assertPathsIdentical('src.cpp', m['source'])
-      seen_lines.add(m['originalLine'])
+      if m['source'] == 'src.cpp':
+        seen_lines.add(m['originalLine'])
     # ensure that all the 'meaningful' lines in the original code get mapped
     # when optimizing, the binaryen optimizer may remove some of them (by inlining, etc.)
     if is_optimizing(self.emcc_args):
-      assert seen_lines.issuperset([11, 12]), seen_lines
+      self.assertTrue(seen_lines.issuperset([11, 12]), seen_lines)
     else:
-      assert seen_lines.issuperset([6, 7, 11, 12]), seen_lines
+      self.assertTrue(seen_lines.issuperset([6, 7, 11, 12]), seen_lines)
 
   @no_wasm2js('TODO: source maps in wasm2js')
   def test_dwarf(self):
@@ -7032,7 +7032,14 @@ def add_section():
     # ------------------ ------ ------ ------ --- ------------- -------------
     # 0x000000000000000b      5      0      3   0             0  is_stmt
     src_to_addr = {}
+    found_src_cpp = False
     for line in sections['.debug_line'].splitlines():
+      if 'name: "src.cpp"' in line:
+        found_src_cpp = True
+      if not found_src_cpp:
+        continue
+      if 'debug_line' in line:
+        break
       if line.startswith('0x'):
         while '  ' in line:
           line = line.replace('  ', ' ')
@@ -7047,7 +7054,8 @@ def add_section():
 
     def get_dwarf_addr(line, col):
       addrs = src_to_addr[(line, col)]
-      assert len(addrs) == 1, 'we assume the simple calls have one address'
+      # we assume the simple calls have one address
+      self.assertEqual(len(addrs), 1)
       return int(addrs[0], 0)
 
     # the lines must appear in sequence (as calls to JS, the optimizer cannot
diff --git a/tests/test_other.py b/tests/test_other.py
index ecafba77a95..0b94d35fe17 100644
--- a/tests/test_other.py
+++ b/tests/test_other.py
@@ -6120,7 +6120,7 @@ def test_zeroinit(self):
   return 0;
 }
 ''')
-    self.run_process([EMCC, 'src.c', '-O2', '-g'])
+    self.run_process([EMCC, 'src.c', '-O2'])
     size = os.path.getsize('a.out.wasm')
     # size should be much smaller than the size of that zero-initialized buffer
     self.assertLess(size, 123456 / 2)
@@ -6508,18 +6508,24 @@ def test_binaryen_names(self):
       ]:
       print(args, expect_names)
       try_delete('a.out.js')
-      # we use dlmalloc here, as emmalloc has a bunch of asserts that contain the text "malloc" in them, which makes counting harder
+      # we use dlmalloc here, as emmalloc has a bunch of asserts that contain the text "malloc" in
+      # them, which makes counting harder
       self.run_process([EMCC, path_from_root('tests', 'hello_world.cpp')] + args + ['-s', 'MALLOC="dlmalloc"', '-s', 'EXPORTED_FUNCTIONS=[_main,_malloc]'])
       code = open('a.out.wasm', 'rb').read()
-      if expect_names:
-        # name section adds the name of malloc (there is also another one for the export)
-        self.assertEqual(code.count(b'malloc'), 2)
+      if '-g' in args:
+        # With -g we get full dwarf info which means we there are many occurances of malloc
+        self.assertGreater(code.count(b'malloc'), 2)
       else:
-        # should be just malloc for the export
-        self.assertEqual(code.count(b'malloc'), 1)
+        if expect_names:
+          # name section adds the name of malloc (there is also another one for the export)
+          self.assertEqual(code.count(b'malloc'), 2)
+        else:
+          # should be just malloc for the export
+          self.assertEqual(code.count(b'malloc'), 1)
       sizes[str(args)] = os.path.getsize('a.out.wasm')
     print(sizes)
-    self.assertLess(sizes["['-O2']"], sizes["['-O2', '--profiling-funcs']"], 'when -profiling-funcs, the size increases due to function names')
+    # when -profiling-funcs, the size increases due to function names
+    self.assertLess(sizes["['-O2']"], sizes["['-O2', '--profiling-funcs']"])
 
   def test_binaryen_warn_mem(self):
     # if user changes INITIAL_MEMORY at runtime, the wasm module may not accept the memory import if
diff --git a/tools/system_libs.py b/tools/system_libs.py
index 18e27fdd8d7..9b97f1b9300 100755
--- a/tools/system_libs.py
+++ b/tools/system_libs.py
@@ -55,8 +55,10 @@ def dir_is_newer(dir_a, dir_b):
   return newest_a < newest_b
 
 
-def get_cflags(force_object_files=False):
-  flags = []
+def get_base_cflags(force_object_files=False):
+  # Always build system libraries with debug information.  Non-debug builds will ignore this
+  # at link time because then link with `-strip-debug`.
+  flags = ['-g']
   if shared.Settings.LTO and not force_object_files:
     flags += ['-flto=' + shared.Settings.LTO]
   if shared.Settings.RELOCATABLE:
@@ -364,17 +366,21 @@ def build_objects(self):
     commands = []
     objects = []
     cflags = self.get_cflags()
+    base_flags = get_base_cflags()
     for src in self.get_files():
       o = in_temp(shared.unsuffixed_basename(src) + '.o')
       ext = shared.suffix(src)
-      if ext in ('.s', '.c'):
+      if ext in ('.s', '.S', '.c'):
         cmd = [shared.EMCC]
       else:
         cmd = [shared.EMXX]
-      if ext != '.s':
+      if ext in ('.s', '.S'):
+        cmd += base_flags
+        # TODO(sbc) There is an llvm bug that causes a crash when `-g` is used with
+        # assembly files that define wasm globals.
+        cmd.remove('-g')
+      else:
         cmd += cflags
-      elif shared.Settings.MEMORY64:
-        cmd += ['-s', 'MEMORY64=' + str(shared.Settings.MEMORY64)]
       commands.append(cmd + ['-c', src, '-o', o])
       objects.append(o)
     run_build_commands(commands)
@@ -404,7 +410,7 @@ def get_cflags(self):
     Override and add any flags as needed to handle new variations.
     """
     cflags = self._inherit_list('cflags')
-    cflags += get_cflags(force_object_files=self.force_object_files)
+    cflags += get_base_cflags(force_object_files=self.force_object_files)
 
     if self.includes:
       cflags += ['-I' + shared.path_from_root(*path) for path in self._inherit_list('includes')]
@@ -1676,7 +1682,7 @@ def add_args(cmd):
       # this must only be called on a standard build command
       assert cmd[0] in (shared.EMCC, shared.EMXX)
       # add standard cflags, but also allow the cmd to override them
-      return cmd[:1] + get_cflags() + cmd[1:]
+      return cmd[:1] + get_base_cflags() + cmd[1:]
     run_build_commands([add_args(c) for c in commands])
 
   @staticmethod
